%
%Script per la soluzione di sistemi sovradeterminati
%
clear all
close all

%% Scelta del sistema da risolvere
scelta_matrice=input('1. Matrice a \n 2. Matrice b \n 3. Matrice c \n 4. Matrice d  \n 5. Matrice e \n 6. Matrice f \n');
switch scelta_matrice
    case 1
        load('matricea.mat');
    case 2
        load('matriceb.mat');
    case 3
        load('matricec.mat');
    case 4
        load('matriced.mat');
    case 5
        load('matricee.mat');
    otherwise
        load('matricef.mat');
end

n=size(A,2);
b=sum(A')';

%% Controllo condizionamento del sistema
fprintf('Dimensioni sistema sovradetrminato  %d x %d  \n',size(A));
[U,S,V]=svd(A);
Condiz=S(1,1)/S(n,n);
fprintf('Indice di condizionamento  %e \n',Condiz);
toll=10^-8;
plot(diag(S))
k = rank(A,toll)

%k=nnz(diag(S)>toll);
fprintf('Rango max (Colonne della matrice) %d --> rango effettivo %d \n',n,k);
if k<n
    disp('la matrice non  a rango massimo')
end

%% Risoluzione sistema sovradeterminato
scegli_metodo=input('1. Eq. Normali \n 2. QR \n 3. SVD \n');

if scegli_metodo==1
    if k==n  %rango massimo
        [x_eqn]=risolvi_EQN(A,b)
        residuo = norm(A*x_eqn-b,2);
    end
elseif scegli_metodo==2
    if k==n
        [x_qr,residuo]= risolvi_QR(A,b)
    end  
elseif scegli_metodo==3
    [x_svd]=risolvi_SVD(A,b,toll)
    residuo = norm(A*x_svd-b,2);
end
fprintf('Norma 2 del residuo || b - Ax ||_2 = %d',residuo);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    
    