clear all
close all
rng(0,'v5uniform') %Fissa sempre allo stesso modo il seme che
%genera il numero casuale cos ad ogni esecuzione abbiamo lo stesso rumore
m=input('Numero di punti di osservazione');
N=input('Dimensione dello spazio dei polinomi');
%N=dimensione dello spazio dei polinomi
%( uguale al grado+1)

%% PUNTI DA APPROSSIMARE (x,y)
x=linspace(-5,5,m)';
y=1./(1+x.^2)+0.001*rand(m,1);

xval=linspace(-5,5,200);
yesatta=1./(1+xval.^2);

%% Crea matrice H
m=length(x);
H=zeros(m,N);
for i=1:N
        H(:,i) = x.^(i-1);
end

%% Determina polinomio approssimante 
%yval = polyapprox(x,y,N,xval,metodo);
[a] = risolvi_EQN(H,y);
%Valutazione del polinomio di approssimazione nei punti xval con lo schema di Horner
%yval = Horner(a,xval);
yval = polyval(fliplr(a'),xval)

%% Grafici punti di approssimazione e polinomio approssimante
figure
plot(xval,yval);
hold on
plot(x,y,'o')
plot(xval,yesatta,'r');