function  [x,errore]=risolvi_QR(H,y,tol)
    
%% se tol==0 allora e' il metodo SVD_LS altrimenti TSVD
[m,n]=size(H);
z=zeros(n,1);
[U,S,V]=svd(H);
sigma = diag(S,0);
d=U'*y;
i=sigma>tol;
z(i)=d(i)./sigma(i); % solo per valori singolari >tol
x=V*z;

%disp('condizionamento del problema')
%cond=sigma(1)/sigma(n)

%% In alternativa con input il numero dei valori singolari da considerare
% function [x]=risolvi_SVD(H,y,r)
% %% se r==min(m,n) allora e' il metodo SVD_LS altrimenti TSVD
% [m,n]=size(H);
% z=zeros(n,1);
% [U,S,V]=svd(H);
% sigma = diag(S,0);
% d=U'*y;
% z(1:r)=d(1:r)./sigma(1:r); % solo per valori singolari 1:r  r< rango
% x=V*z;

%% In alternativa
% n=size(H,2);
% x=zeros(n,1);
% for i=1:k
%     x = x + (U(:,i)'*y)*V(:,i)/S(i,i);
% end    

