function [x,errore]=risolvi_QR(H,y)
% Fattorizzazione QR della matrice H
[m,n] = size(H);
[Q,R] = qr(H);
 
% Costruzione di R1 e c1
R1=R(1:n,1:n);
c = Q' * y;
c1 = c(1 : n);
x = R1\c1;  
% calcolo del residuo r=Ha-y
c2 = c(n+1:m);
errore=norm(c2,2);
  